Pages/Admin/Censor.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Project_PRN221_1.Models;

namespace Project_PRN221_1.Pages.Admin
{
    public class CensorModel : PageModel
    {
        private readonly Project_PRN221_1Context _context;
        public CensorModel(Project_PRN221_1Context context)
        {
            _context = context;
        }

        public List<Category> Categories { get; set; }

        public List<Post> Posts { get; set; }
        public void OnGet()
        {
            Categories = _context.Categories.ToList();
            Posts = _context.Posts.Include(post => post.User).Where(post => post.IsCensor == 0).OrderByDescending(p => p.PostDate).ToList();
        }
    }
}

Pages/Admin/UserManage.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Project_PRN221_1.Models;

namespace Project_PRN221_1.Pages.Admin
{
    public class UserManageModel : PageModel
    {
        private readonly Project_PRN221_1Context _context;

        public UserManageModel(Project_PRN221_1Context context)
        {
            _context = context;
        }

        public List<Category> Categories { get; set; }

        public List<User> Users { get; set; }

        [BindProperty]
        public User u { get; set; } 
        public void OnGet()
        {
            Categories = _context.Categories.ToList();
            Users = _context.Users.Include(x => x.Role).ToList(); 

        }
        // delete user
        public IActionResult OnPost(int userId)
        {
			Categories = _context.Categories.ToList();
            
            var userToDelete = _context.Users.FirstOrDefault(u => u.UserId == userId);
            if (userToDelete != null)
            {
                var userPosts = _context.Posts.Where(p => p.UserId == userId).ToList();
                foreach (var post in userPosts)
                {
                    var postComments = _context.Comments.Where(c => c.PostId == post.PostId).ToList();
                    foreach (var comment in postComments)
                    {
                        _context.Comments.Remove(comment);
                    }
                    _context.Posts.Remove(post);
                }

                var userComments = _context.Comments.Where(c => c.UserId == userId).ToList();
                foreach (var comment in userComments)
                {
                    _context.Comments.Remove(comment);
                }
                _context.Users.Remove(userToDelete);
                _context.SaveChanges();
            }
            Users = _context.Users.Include(x => x.Role).ToList();
            return Page();
		}

        // set as censor
        public IActionResult OnPostSetCensor(int userId)
        {
            Categories = _context.Categories.ToList();
            var userToCensor = _context.Users.FirstOrDefault(u => u.UserId == userId);
            if (userToCensor != null)
            {
                userToCensor.RoleId = 3;
                _context.Users.Update(userToCensor);
                _context.SaveChanges();
            }
            Users = _context.Users.Include(x => x.Role).ToList();
            return Page();
        }
        //unset censor
        public IActionResult OnPostUnsetCensor(int userId)
        {
            Categories = _context.Categories.ToList();
            var userToUncensor = _context.Users.FirstOrDefault(u => u.UserId == userId);
            if (userToUncensor != null)
            {
                userToUncensor.RoleId = 1;
                _context.Users.Update(userToUncensor);
                _context.SaveChanges();
            }
            Users = _context.Users.Include(x => x.Role).ToList();
            return Page();
        }

        //deactive user
        public IActionResult OnPostDeactive(int userId)
        {
            Categories = _context.Categories.ToList();
            var userToDeactive = _context.Users.FirstOrDefault(u => u.UserId == userId);
            if (userToDeactive != null)
            {
                userToDeactive.IsActive = 0;
                _context.Users.Update(userToDeactive);
                _context.SaveChanges();
            }
            Users = _context.Users.Include(x => x.Role).ToList();
            return Page();
        }
    }
}

Pages/UserManage/Profile.cshtml.cs
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.EntityFrameworkCore;
using Project_PRN221_1.Models;

namespace Project_PRN221_1.Pages.UserManage
{
    public class ProfileModel : PageModel
    {
        private readonly Project_PRN221_1Context _context;

        public string ConfirmPassword;
        public ProfileModel(Project_PRN221_1Context context)
        {
            _context = context;
        }

        public List<Category> Categories { get; set; }
        [BindProperty]
        public User user { get; set; }

        public void OnGet()
        {
            Categories = _context.Categories.ToList();
            int uId = int.Parse(HttpContext.Session.GetString("UserId"));
            if (uId != null)
            {
                user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == uId);
            }
        }
        public IActionResult OnPostUpdateProfile()
        {
            Categories = _context.Categories.ToList();
            int uId = int.Parse(HttpContext.Session.GetString("UserId"));
            var userFromDb = _context.Users.AsNoTracking().FirstOrDefault(u => u.UserId == user.UserId);
            if (userFromDb != null)
            {
                if (userFromDb.Email != user.Email)
                {
                    var existingUser = _context.Users.FirstOrDefault(u => u.Email == user.Email);
                    if (existingUser != null)
                    {
                        user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == uId);
                        ModelState.AddModelError("user.Email", "Email already exists.");
                        return Page();
                    }
                    else
                    {
                        userFromDb.Email = user.Email;
                        _context.Entry(userFromDb).State = EntityState.Modified;
                        _context.SaveChanges();
                        user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == uId);
                    }
                }
                else
                {
                    userFromDb.Name = user.Name;
                    userFromDb.Email = user.Email;
                    _context.Entry(userFromDb).State = EntityState.Modified;
                    _context.SaveChanges();
                    user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == uId);
                }
            }
            return Page();
        }

        public IActionResult OnPostUpdatePassword()
        {
            int userId = int.Parse(HttpContext.Session.GetString("UserId"));
            user = _context.Users.Include(r => r.Role).FirstOrDefault(u => u.UserId == userId);
            Categories = _context.Categories.ToList();
            string currentPassword = Request.Form["currentPassword"];
            string newPassword = Request.Form["newPassword"];
            string confirmPassword = Request.Form["confirmPassword"];

            if (VerifyCurrentPassword(currentPassword))
            {
                if (newPassword == confirmPassword)
                {
                    if (newPassword != currentPassword)
                    {
                        int roleId = user.RoleId;
                        user.RoleId = roleId;
                        user.Password = newPassword;
                        _context.SaveChanges();
                        return RedirectToPage();
                    }
                    else
                    {
                        ModelState.AddModelError("newPassword", "New password must be different from the current password.");
                    }
                }
                else
                {
                    ModelState.AddModelError("confirmPassword", "Confirm password does not match the new password.");
                }
            }
            else
            {
                ModelState.AddModelError("currentPassword", "Current password is incorrect.");
            }
            return Page();
        }

        private bool VerifyCurrentPassword(string currentPassword)
        {
            bool isMatch = false;
            if (user.Password != null && user.Password.Equals(currentPassword, StringComparison.OrdinalIgnoreCase))
            {
                isMatch = true;
            }
            return isMatch;
        }
    }
}

Pages/Admin/Censor.cshtml
@page
@model Project_PRN221_1.Pages.Admin.CensorModel
@{
}
<h1>List Posts To Censor</h1>

@if (Model.Posts != null && Model.Posts.Any())
{
    <table class="table">
        <thead>
            <tr>
                <th>Title</th>
                <th>Author</th>
                <th>Post Date</th>
                <th>Link</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var post in Model.Posts)
            {
                <tr>
                    <td>@post.PostHeader</td>
                    <td>@post.User.Name</td>
                    <td>@post.PostDate</td>
                    <td>
                        <a href="/ArticleDetails?id=@post.PostId">View Detail</a>
                    </td>
                </tr>
            }
        </tbody>
    </table>
}
else
{
    <p>No posts left to censor</p>
}

Pages/Admin/UserManage.cshtml
@page
@model Project_PRN221_1.Pages.Admin.UserManageModel
@{
}
<style>
    .table {
        width: 100%;
        border-collapse: collapse;
        margin-bottom: 20px;
    }

        .table th,
        .table td {
            padding: 8px;
            border: 1px solid #ddd;
        }

        .table th {
            background-color: #f2f2f2;
            font-weight: bold;
        }

        .table tr:nth-child(even) {
            background-color: #f2f2f2;
        }

        .table tr:hover {
            background-color: #ddd;
        }

    .btn {
        display: inline-block;
        padding: 8px 16px;
        border: 1px solid #007bff;
        border-radius: 4px;
        background-color: #007bff;
        color: #fff;
        text-decoration: none;
    }

        .btn:hover {
            background-color: #0056b3;
        }

    .btn-primary {
        background-color: #007bff;
        border-color: #007bff;
    }

        .btn-primary:hover {
            background-color: #0056b3;
            border-color: #0056b3;
        }

    .btn-danger {
        background-color: #dc3545;
        border-color: #dc3545;
    }

        .btn-danger:hover {
            background-color: #c82333;
            border-color: #bd2130;
        }

    .btn-secondary {
        background-color: #28a745;
        border-color: #28a745;
    }

        .btn-secondary:hover {
            background-color: #218838;
            border-color: #1e7e34;
        }

    .btn-warning {
        background-color: #ffc107; 
        border-color: #ffc107;
    }

        .btn-warning:hover {
            background-color: #e0a800;
            border-color: #e0a800; 
        }
</style>
<h1>Manage Users</h1>

<table class="table">
    <thead>
        <tr>
            <th>Username</th>
            <th>Email</th>
            <th>Role</th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var user in Model.Users)
        {
            <tr>
                <td>@user.Username</td>
                <td>@user.Email</td>
                <td>@user.Role.RoleName</td>
                <td>
                    @if (user.RoleId != 2)
                    {
                        @if (user.RoleId == 1)
                        {
                            <form method="post" asp-page-handler="SetCensor">
                                <button type="submit" class="btn btn-primary">Set as Censor</button>
                                <input type="hidden" name="u" value="@user" />
                                <input type="hidden" name="userId" value="@user.UserId" />
                            </form>
                        }
                        else if (user.RoleId == 3)
                        {
                            <form method="post" asp-page-handler="UnsetCensor">
                                <button type="submit" class="btn btn-secondary">Unset as Censor</button>
                                <input type="hidden" name="u" value="@user" />
                                <input type="hidden" name="userId" value="@user.UserId" />
                            </form>
                        }
                        @if (user.IsActive == 1)
                        {
                            <form method="post" asp-page-handler="Deactive">
                                <button type="submit" class="btn btn-warning">Deactive</button>
                                <input type="hidden" name="u" value="@user" />
                                <input type="hidden" name="userId" value="@user.UserId" />
                            </form>
                        }
                        <form method="post">
                            <button type="submit" class="btn btn-danger">Delete</button>
                            <input type="hidden" name="u" value="@user" />
                            <input type="hidden" name="userId" value="@user.UserId" />
                        </form>
                    }

                </td>
            </tr>
        }
    </tbody>
</table>